﻿''
'' ConsoleVB
''
'' Copyright (c) 2016 http://www.curict.com
'' This software is released under the MIT License, see LICENSE.txt.
''

Module Module1

    Sub Main()
        Try
            Case1()
        Catch ex As Exception
            Console.WriteLine(ex.Message)
        End Try

        Try
            Case2()
        Catch ex As Exception
            Console.WriteLine(ex.Message)
        End Try

        Try
            Case3()
        Catch ex As Exception
            Console.WriteLine(ex.Message)
        End Try

        Console.ReadLine()
    End Sub

    ''' <summary>
    ''' Null条件演算子「?.」
    ''' </summary>
    Sub Case1()
        ' nullを代入
        Dim str As String = Nothing

        ' ?.演算子を使用すると result に Nothing がセットされ、例外は発生しない
        Dim result As String = str?.Trim()

        ' 例外 NullReferenceException が発生
        result = str.Trim()
    End Sub

    ''' <summary>
    ''' Null条件演算子「?.」
    ''' </summary>
    Sub Case2()
        ' nullを代入
        Dim strArray As String() = Nothing

        ' ?. 演算子を使用すると length に Nothing がセットされ、例外は発生しない
        Dim length As Integer? = strArray?.Length

        ' 【注意】 null許容型の変数に代入しないと 例外:ThrowInvalidOperationException が発生します。
        ' 次の例は null許容型ではなく、通常のIntegerに代入しているので例外が発生します。
        ' Dim length As Integer = strArray?.Length

        ' 例外 NullReferenceException が発生
        length = strArray.Length
    End Sub

    ''' <summary>
    ''' Null条件演算子「?(」
    ''' </summary>
    Sub Case3()
        ' nullを代入
        Dim strArray As String() = Nothing

        ' ?( 演算子を使用すると strValue に Nothing がセットされ、例外は発生しない
        Dim strValue As String = strArray?(0)

        ' 例外 NullReferenceException が発生
        strValue = strArray(0)
    End Sub

End Module
